diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/nand/au1550nd.c linux-2.4.30/drivers/mtd/nand/au1550nd.c
--- linux-2.4.30-orig/drivers/mtd/nand/au1550nd.c	2005-05-12 18:01:30.000000000 +0200
+++ linux-2.4.30/drivers/mtd/nand/au1550nd.c	2006-12-11 18:18:37.000000000 +0100
@@ -3,7 +3,7 @@
  *
  *  Copyright (C) 2004 Embedded Edge, LLC
  *
- * $Id: au1550nd.c,v 1.4 2004/05/12 06:23:58 ppopov Exp $
+ * $Id: au1550nd.c,v 1.5 2005/10/14 11:24:32 lel Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -18,238 +18,532 @@
 #include <linux/mtd/nand.h>
 #include <linux/mtd/partitions.h>
 #include <asm/io.h>
-#include <asm/au1000.h>
 
-#ifdef CONFIG_MIPS_PB1550
-#include <asm/pb1550.h> 
-#define NAND_STCFG  0x00400005 /* 8-bit NAND */
-#define NAND_STTIME 0x00007774 /* valid for 396MHz SD=2 only */
-#define NAND_STADDR 0x12000FFF /* physical address 0x20000000 */
+#undef AU_NAND_DISABLE_INTERRUPTS
+
+#ifdef AU_NAND_DISABLE_INTERRUPTS
+#include <linux/interrupt.h>
 #endif
 
+/* fixme: this is ugly */
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 0)
+#include <asm/mach-au1x00/au1000.h>
+#ifdef CONFIG_MIPS_PB1550
+#include <asm/mach-pb1x00/pb1550.h> 
+#endif
 #ifdef CONFIG_MIPS_DB1550
-#define NAND_CS 1
-#define NAND_STCFG  0x00400005 /* 8-bit NAND */
-#define NAND_STTIME 0x00007774 /* valid for 396MHz SD=2 only */
-#define NAND_STADDR 0x12000FFF /* physical address 0x20000000 */
+#include <asm/mach-db1x00/db1x00.h> 
 #endif
-
-#ifdef CONFIG_MIPS_PB1200
-#define NAND_CS 1
+#else /* LINUX_VERSION ... */
+#include <asm/au1000.h>
+#ifdef CONFIG_MIPS_PB1550
+#include <asm/pb1550.h> 
 #endif
-
-#ifdef CONFIG_MIPS_DB1200
-#define NAND_CS 1
+#ifdef CONFIG_MIPS_DB1550
+#include <asm/db1x00.h> 
+#endif
+#ifdef CONFIG_MIPS_I3_MMB3
+#include <asm/mood300.h>
 #endif
-
-#ifndef NAND_CS
-#error "NAND_CS must be defined as 0, 1, 2 or 3, as appropriate"
 #endif
-
 
 /*
  * MTD structure for NAND controller
  */
-static struct mtd_info *au1xxx_nand_mtd = NULL;
-static volatile u32 p_nand;
-static int nand_width = 1; /* default, only x8 supported for now */
-
-/* Internal buffers. Page buffer and oob buffer for one block*/
-static u_char data_buf[512 + 16];
-static u_char oob_buf[16 * 32];
+static struct mtd_info *au1550_mtd = NULL;
+static void __iomem *p_nand;
+static int nand_width = 1; /* default x8*/
 
 /*
  * Define partitions for flash device
  */
 const static struct mtd_partition partition_info[] = {
+#ifndef CONFIG_MIPS_I3_MMB3 
 	{ 
-		.name = "NAND FS 0",
+		.name 	= "NAND FS 0",
+	  	.offset = 0,
+	  	.size 	= 8*1024*1024 
+	},
+	{ 
+		.name	= "NAND FS 1",
+		.offset =  MTDPART_OFS_APPEND,
+ 		.size	=    MTDPART_SIZ_FULL
+	}
+#else
+        { 
+		.name = "Mood 300 NAND FS 0",
 	  	.offset = 0,
-	  	.size = 8*1024*1024 
+	  	.size = 4*1024*1024 
 	},
 	{ 
-		.name = "NAND FS 1",
+		.name = "Mood 300 NAND FS 1",
 		.offset =  MTDPART_OFS_APPEND,
  		.size =    MTDPART_SIZ_FULL
 	}
+#endif
 };
 #define NB_OF(x)  (sizeof(x)/sizeof(x[0]))
 
-static inline void write_cmd_reg(u8 cmd)
+
+/**
+ * au_nand_select_chip_override - [DEFAULT] control CE line
+ * @mtd:        MTD device structure
+ * @chip:       chipnumber to select, -1 for deselect
+ *
+ * Default select function for 1 chip devices.
+ */
+static void au_nand_select_chip_override(struct mtd_info *mtd, int chip)
 {
-	if (nand_width)
-		*((volatile u8 *)(p_nand + MEM_STNAND_CMD)) = cmd;
-	else
-		*((volatile u16 *)(p_nand + MEM_STNAND_CMD)) = cmd;
+        struct nand_chip *this = mtd->priv;
+        switch(chip) {
+        case -1:
+                this->hwcontrol(mtd, NAND_CTL_CLRNCE);
+                break;
+        case 0:
+                this->hwcontrol(mtd, NAND_CTL_SETNCE);
+                break;
+
+        default:
+                BUG();
+        }
+}
+
+/* 
+ * Wait for the ready pin, after a command
+ * The timeout is catched later.
+ */
+static void nand_wait_ready(struct mtd_info *mtd)
+{
+	struct nand_chip *this = mtd->priv;
+	unsigned long	timeo = jiffies + 2;
+
+	/* wait until command is processed or timeout occures */
+	do {
+		if (this->dev_ready(mtd))
+			return;
+	} while (time_before(jiffies, timeo));	
+}
+
+/**
+ * au_read_byte -  read one byte from the chip
+ * @mtd:	MTD device structure
+ *
+ *  read function for 8bit buswith
+ */
+static u_char au_read_byte(struct mtd_info *mtd)
+{
+	struct nand_chip *this = mtd->priv;
+	u_char ret = readb(this->IO_ADDR_R);
 	au_sync();
+	return ret;
 }
 
-static inline void write_addr_reg(u8 addr)
+/**
+ * au_write_byte -  write one byte to the chip
+ * @mtd:	MTD device structure
+ * @byte:	pointer to data byte to write
+ *
+ *  write function for 8it buswith
+ */
+static void au_write_byte(struct mtd_info *mtd, u_char byte)
 {
-	if (nand_width)
-		*((volatile u8 *)(p_nand + MEM_STNAND_ADDR)) = addr;
-	else
-		*((volatile u16 *)(p_nand + MEM_STNAND_ADDR)) = addr;
+	struct nand_chip *this = mtd->priv;
+	writeb(byte, this->IO_ADDR_W);
 	au_sync();
 }
 
-static inline void write_data_reg(u8 data)
+/**
+ * au_read_byte16 -  read one byte endianess aware from the chip
+ * @mtd:	MTD device structure
+ *
+ *  read function for 16bit buswith with 
+ * endianess conversion
+ */
+static u_char au_read_byte16(struct mtd_info *mtd)
 {
-	if (nand_width)
-		*((volatile u8 *)(p_nand + MEM_STNAND_DATA)) = data;
-	else
-		*((volatile u16 *)(p_nand + MEM_STNAND_DATA)) = data;
+	struct nand_chip *this = mtd->priv;
+	u_char ret = (u_char) cpu_to_le16(readw(this->IO_ADDR_R));
 	au_sync();
+	return ret;
 }
 
-static inline u32 read_data_reg(void)
+/**
+ * au_write_byte16 -  write one byte endianess aware to the chip
+ * @mtd:	MTD device structure
+ * @byte:	pointer to data byte to write
+ *
+ *  write function for 16bit buswith with
+ * endianess conversion
+ */
+static void au_write_byte16(struct mtd_info *mtd, u_char byte)
 {
-	u32 data;
-	if (nand_width) {
-		data = *((volatile u8 *)(p_nand + MEM_STNAND_DATA));
-		au_sync();
-	}
-	else {
-		data = *((volatile u16 *)(p_nand + MEM_STNAND_DATA));
-		au_sync();
-	}
-	return data;
+	struct nand_chip *this = mtd->priv;
+	writew(le16_to_cpu((u16) byte), this->IO_ADDR_W);
+	au_sync();
 }
 
-void au1xxx_hwcontrol(struct mtd_info *mtd, int cmd)
+/**
+ * au_read_word -  read one word from the chip
+ * @mtd:	MTD device structure
+ *
+ *  read function for 16bit buswith without 
+ * endianess conversion
+ */
+static u16 au_read_word(struct mtd_info *mtd)
 {
+	struct nand_chip *this = mtd->priv;
+	u16 ret = readw(this->IO_ADDR_R);
+	au_sync();
+	return ret;
 }
 
-int au1xxx_device_ready(struct mtd_info *mtd)
+/**
+ * au_write_word -  write one word to the chip
+ * @mtd:	MTD device structure
+ * @word:	data word to write
+ *
+ *  write function for 16bit buswith without 
+ * endianess conversion
+ */
+static void au_write_word(struct mtd_info *mtd, u16 word)
 {
-	int ready;
-	ready = (au_readl(MEM_STSTAT) & 0x1) ? 1 : 0;
-	return ready;
+	struct nand_chip *this = mtd->priv;
+	writew(word, this->IO_ADDR_W);
+	au_sync();
 }
 
-static u_char au1xxx_nand_read_byte(struct mtd_info *mtd)
+/**
+ * au_write_buf -  write buffer to chip
+ * @mtd:	MTD device structure
+ * @buf:	data buffer
+ * @len:	number of bytes to write
+ *
+ *  write function for 8bit buswith
+ */
+static void au_write_buf(struct mtd_info *mtd, const u_char *buf, int len)
 {
-	u_char ret;
-	ret = read_data_reg();
-	return ret;
+	int i;
+	struct nand_chip *this = mtd->priv;
+
+	for (i=0; i<len; i++) {
+		writeb(buf[i], this->IO_ADDR_W);
+		au_sync();
+	}
 }
 
-static void au1xxx_nand_write_byte(struct mtd_info *mtd, u_char byte)
+/**
+ * au_read_buf -  read chip data into buffer 
+ * @mtd:	MTD device structure
+ * @buf:	buffer to store date
+ * @len:	number of bytes to read
+ *
+ *  read function for 8bit buswith
+ */
+static void au_read_buf(struct mtd_info *mtd, u_char *buf, int len)
 {
-	write_data_reg((u8)byte);
+	int i;
+	struct nand_chip *this = mtd->priv;
+
+	for (i=0; i<len; i++) {
+		buf[i] = readb(this->IO_ADDR_R);
+		au_sync();	
+	}
 }
 
-static void 
-au1xxx_nand_write_buf(struct mtd_info *mtd, const u_char *buf, int len)
+/**
+ * au_verify_buf -  Verify chip data against buffer 
+ * @mtd:	MTD device structure
+ * @buf:	buffer containing the data to compare
+ * @len:	number of bytes to compare
+ *
+ *  verify function for 8bit buswith
+ */
+static int au_verify_buf(struct mtd_info *mtd, const u_char *buf, int len)
 {
 	int i;
+	struct nand_chip *this = mtd->priv;
 
-	for (i=0; i<len; i++)
-		write_data_reg(buf[i]);
+	for (i=0; i<len; i++) {
+		if (buf[i] != readb(this->IO_ADDR_R))
+			return -EFAULT;
+		au_sync();
+	}
+
+	return 0;
 }
 
-static void 
-au1xxx_nand_read_buf(struct mtd_info *mtd, u_char *buf, int len)
+/**
+ * au_write_buf16 -  write buffer to chip
+ * @mtd:	MTD device structure
+ * @buf:	data buffer
+ * @len:	number of bytes to write
+ *
+ *  write function for 16bit buswith
+ */
+static void au_write_buf16(struct mtd_info *mtd, const u_char *buf, int len)
 {
 	int i;
+	struct nand_chip *this = mtd->priv;
+	u16 *p = (u16 *) buf;
+	len >>= 1;
+	
+	for (i=0; i<len; i++) {
+		writew(p[i], this->IO_ADDR_W);
+		au_sync();
+	}
+		
+}
+
+/**
+ * au_read_buf16 -  read chip data into buffer 
+ * @mtd:	MTD device structure
+ * @buf:	buffer to store date
+ * @len:	number of bytes to read
+ *
+ *  read function for 16bit buswith
+ */
+static void au_read_buf16(struct mtd_info *mtd, u_char *buf, int len)
+{
+	int i;
+	struct nand_chip *this = mtd->priv;
+	u16 *p = (u16 *) buf;
+	len >>= 1;
 
-	for (i=0; i<len; i++)
-		buf[i] = (u_char)read_data_reg();
+	for (i=0; i<len; i++) {
+		p[i] = readw(this->IO_ADDR_R);
+		au_sync();
+	}
 }
 
-static int 
-au1xxx_nand_verify_buf(struct mtd_info *mtd, const u_char *buf, int len)
+/**
+ * au_verify_buf16 -  Verify chip data against buffer 
+ * @mtd:	MTD device structure
+ * @buf:	buffer containing the data to compare
+ * @len:	number of bytes to compare
+ *
+ *  verify function for 16bit buswith
+ */
+static int au_verify_buf16(struct mtd_info *mtd, const u_char *buf, int len)
 {
 	int i;
+	struct nand_chip *this = mtd->priv;
+	u16 *p = (u16 *) buf;
+	len >>= 1;
 
-	for (i=0; i<len; i++)
-		if (buf[i] != (u_char)read_data_reg())
+	for (i=0; i<len; i++) {
+		if (p[i] != readw(this->IO_ADDR_R))
 			return -EFAULT;
-
+		au_sync();
+	}
 	return 0;
 }
 
-static void au1xxx_nand_select_chip(struct mtd_info *mtd, int chip)
+
+static void au1550_hwcontrol(struct mtd_info *mtd, int cmd)
 {
-	switch(chip) {
-	case -1:
-		/* deassert chip enable */
-		au_writel(au_readl(MEM_STNDCTL) & ~(1<<(4+NAND_CS)), MEM_STNDCTL);
+	register struct nand_chip *this = mtd->priv;
+
+	switch(cmd){
+
+	case NAND_CTL_SETCLE: this->IO_ADDR_W = p_nand + MEM_STNAND_CMD; break;
+	case NAND_CTL_CLRCLE: this->IO_ADDR_W = p_nand + MEM_STNAND_DATA; break;
+
+	case NAND_CTL_SETALE: this->IO_ADDR_W = p_nand + MEM_STNAND_ADDR; break;
+	case NAND_CTL_CLRALE: 
+		this->IO_ADDR_W = p_nand + MEM_STNAND_DATA; 
+		/* FIXME: Nobody knows why this is neccecary, 
+		 * but it works only that way */
+		udelay(1); 
 		break;
-	case 0:
+
+	case NAND_CTL_SETNCE: 
 		/* assert (force assert) chip enable */
-		au_writel(au_readl(MEM_STNDCTL) | (1<<(4+NAND_CS)) , MEM_STNDCTL);
+		au_writel((1<<(4+NAND_CS)) , MEM_STNDCTL); break;
 		break;
 
-	default:
-		BUG();
+	case NAND_CTL_CLRNCE: 
+ 		/* deassert chip enable */
+		au_writel(0, MEM_STNDCTL); break;
+		break;
 	}
+
+	this->IO_ADDR_R = this->IO_ADDR_W;
+	
+	/* Drain the writebuffer */
+	au_sync();
 }
 
-static void au1xxx_nand_command (struct mtd_info *mtd, unsigned command, 
-		int column, int page_addr)
+int au1550_device_ready(struct mtd_info *mtd)
 {
-	register struct nand_chip *this = mtd->priv;
+	int ret = (au_readl(MEM_STSTAT) & 0x1) ? 1 : 0;
+	au_sync();
+	return ret;
+}
 
-	/*
-	 * Write out the command to the device.
-	 */
-	if (command == NAND_CMD_SEQIN) {
-		int readcmd;
-
-		if (column >= mtd->oobblock) {
-			/* OOB area */
-			column -= mtd->oobblock;
-			readcmd = NAND_CMD_READOOB;
-		} else if (column < 256) {
-			/* First 256 bytes --> READ0 */
-			readcmd = NAND_CMD_READ0;
-		} else {
-			column -= 256;
-			readcmd = NAND_CMD_READ1;
-		}
-		write_cmd_reg(readcmd);
-	}
-	write_cmd_reg(command);
-
-	if (column != -1 || page_addr != -1) {
-
-		/* Serially input address */
-		if (column != -1)
-			write_addr_reg(column);
-		if (page_addr != -1) {
-			write_addr_reg((unsigned char) (page_addr & 0xff));
-			write_addr_reg(((page_addr >> 8) & 0xff));
-			/* One more address cycle for higher density devices */
-			if (mtd->size & 0x0c000000) 
-				write_addr_reg((unsigned char) ((page_addr >> 16) & 0x0f));
-		}
-	}
-	
-	switch (command) {
-			
-	case NAND_CMD_PAGEPROG:
-	case NAND_CMD_ERASE1:
-	case NAND_CMD_ERASE2:
-	case NAND_CMD_SEQIN:
-	case NAND_CMD_STATUS:
-		break;
 
-	case NAND_CMD_RESET:
-		if (this->dev_ready)	
-			break;
-		udelay(this->chip_delay);
-		write_cmd_reg(NAND_CMD_STATUS);
-		while ( !(read_data_reg() & 0x40));
-		return;
+/**
+ * au_select_chip - Do not drive CS manual by default.
+ *      Nand flash controller do that automatically.
+        We use manual CS drive only in NAND_CMD_READ0 and NAND_CMD_READOOB.
+ * @mtd:        MTD device structure
+ * @chip:       chipnumber to select, -1 for deselect
+ *
+ * Default select function for 1 chip devices.
+ */
+static void au_select_chip(struct mtd_info *mtd, int chip)
+{
 
-	/* This applies to read commands */	
+}
+
+/**
+ * nand_command - [DEFAULT] Send command to NAND device
+ * @mtd:        MTD device structure
+ * @command:    the command to be sent
+ * @column:     the column address for this command, -1 if none
+ * @page_addr:  the page address for this command, -1 if none
+ *
+ * Send command to NAND device. This function is used for small page
+ * devices (256/512 Bytes per page)
+ */
+static void au_command (struct mtd_info *mtd, unsigned command, int column, int page_addr)
+{
+        register struct nand_chip *this = mtd->priv;
+#ifdef AU_NAND_DISABLE_INTERRUPTS
+        unsigned long g_cpu_flags_cmd = 0;
+#endif
+	int cmd_is_read = 0;
+
+	/* Decide wether command needs to force-enable CS or not */
+	switch (command) {
+	case NAND_CMD_READ0:
+	case NAND_CMD_READ1:
+	case NAND_CMD_READOOB:
+	case NAND_CMD_READID:
+		cmd_is_read = 1;
+		break;
 	default:
-		udelay (this->chip_delay);
+		break;
 	}
-	
-	/* wait until command is processed */
-	while (!this->dev_ready(mtd));
+
+        /* Begin command latch cycle */
+        this->hwcontrol(mtd, NAND_CTL_SETCLE);
+        /*
+         * Write out the command to the device.
+         */
+        if (command == NAND_CMD_SEQIN) {
+                int readcmd;
+
+                if (column >= mtd->oobblock) {
+                        /* OOB area */
+                        column -= mtd->oobblock;
+                        readcmd = NAND_CMD_READOOB;
+                } else if (column < 256) {
+                        /* First 256 bytes --> READ0 */
+                        readcmd = NAND_CMD_READ0;
+                } else {
+                        column -= 256;
+                        readcmd = NAND_CMD_READ1;
+                }
+                this->write_byte(mtd, readcmd);
+        }
+        this->write_byte(mtd, command);
+
+        /* Set ALE and clear CLE to start address cycle */
+        this->hwcontrol(mtd, NAND_CTL_CLRCLE);
+
+        if (column != -1 || page_addr != -1) {
+                this->hwcontrol(mtd, NAND_CTL_SETALE);
+
+                /* Serially input address */
+                if (column != -1) {
+                        /* Adjust columns for 16 bit buswidth */
+                        if (this->options & NAND_BUSWIDTH_16) {
+                                column >>= 1;
+			}
+                        if( cmd_is_read ) {
+#ifdef AU_NAND_DISABLE_INTERRUPTS
+                                save_flags(g_cpu_flags_cmd);
+                                cli();
+#endif
+                                au_nand_select_chip_override( mtd, 0 );
+			}
+                        this->write_byte(mtd, column);
+                }
+                if (page_addr != -1) {
+                        this->write_byte(mtd, (unsigned char) (page_addr & 0xff));
+                        this->write_byte(mtd, (unsigned char) ((page_addr >> 8) & 0xff));
+
+                        if( cmd_is_read ){
+#ifdef AU_NAND_DISABLE_INTERRUPTS
+                                save_flags(g_cpu_flags_cmd);
+                                cli();
+#endif
+                                au_nand_select_chip_override( mtd, 0 );
+                        }
+
+
+                        /* One more address cycle for devices > 32MiB */
+                        if (this->chipsize > (32 << 20))
+                                this->write_byte(mtd, (unsigned char) ((page_addr >> 16) & 0x0f));
+                }
+                /* Latch in address */
+                this->hwcontrol(mtd, NAND_CTL_CLRALE);
+        }
+
+        /*
+         * program and erase have their own busy handlers
+         * status and sequential in needs no delay
+        */
+        switch (command) {
+
+        case NAND_CMD_PAGEPROG:
+        case NAND_CMD_ERASE1:
+        case NAND_CMD_ERASE2:
+        case NAND_CMD_SEQIN:
+        case NAND_CMD_STATUS:
+                return;
+
+        case NAND_CMD_RESET:
+                if (this->dev_ready)
+                        break;
+                udelay(this->chip_delay);
+                this->hwcontrol(mtd, NAND_CTL_SETCLE);
+                this->write_byte(mtd, NAND_CMD_STATUS);
+                this->hwcontrol(mtd, NAND_CTL_CLRCLE);
+                while ( !(this->read_byte(mtd) & NAND_STATUS_READY));
+                return;
+
+        /* This applies to read commands */
+        default:
+                /*
+                 * If we don't have access to the busy pin, we apply the given
+                 * command delay
+                */
+
+                if (!this->dev_ready) {
+                        udelay (this->chip_delay);
+                        if( cmd_is_read ) {
+                                goto au1550_nand_restore_flags;
+			}
+                        return;
+                }
+        }
+        /* Apply this short delay always to ensure that we do wait tWB in
+         * any case on any machine. */
+        ndelay (100);
+
+        nand_wait_ready(mtd);
+
+        if( cmd_is_read )
+                goto au1550_nand_restore_flags;
+
+        return;
+
+au1550_nand_restore_flags:
+        au_nand_select_chip_override( mtd, -1 );
+#ifdef AU_NAND_DISABLE_INTERRUPTS
+        restore_flags(g_cpu_flags_cmd);
+#endif
 }
 
 
@@ -259,31 +553,35 @@
 int __init au1xxx_nand_init (void)
 {
 	struct nand_chip *this;
+#ifdef CONFIG_MIPS_PB1550
 	u16 boot_swapboot = 0; /* default value */
+#endif
+	int retval;
 	u32 mem_staddr;
 	u32 nand_phys;
 
 	/* Allocate memory for MTD device structure and private data */
-	au1xxx_nand_mtd = kmalloc (sizeof(struct mtd_info) + 
+	au1550_mtd = kmalloc (sizeof(struct mtd_info) + 
 			sizeof (struct nand_chip), GFP_KERNEL);
-	if (!au1xxx_nand_mtd) {
+	if (!au1550_mtd) {
 		printk ("Unable to allocate NAND MTD dev structure.\n");
 		return -ENOMEM;
 	}
 
 	/* Get pointer to private data */
-	this = (struct nand_chip *) (&au1xxx_nand_mtd[1]);
+	this = (struct nand_chip *) (&au1550_mtd[1]);
 
 	/* Initialize structures */
-	memset((char *) au1xxx_nand_mtd, 0, sizeof(struct mtd_info));
+	memset((char *) au1550_mtd, 0, sizeof(struct mtd_info));
 	memset((char *) this, 0, sizeof(struct nand_chip));
 
 	/* Link the private data with the MTD structure */
-	au1xxx_nand_mtd->priv = this;
+	au1550_mtd->priv = this;
+
 
 	/* disable interrupts */
 	au_writel(au_readl(MEM_STNDCTL) & ~(1<<8), MEM_STNDCTL);
-
+ 
 	/* disable NAND boot */
 	au_writel(au_readl(MEM_STNDCTL) & ~(1<<0), MEM_STNDCTL);
 
@@ -291,7 +589,6 @@
 	/* set gpio206 high */
 	au_writel(au_readl(GPIO2_DIR) & ~(1<<6), GPIO2_DIR);
 
-	/* Pb1550: check boot configuration to make sure NAND is visible */
 	boot_swapboot = (au_readl(MEM_STSTAT) & (0x7<<1)) | 
 		((bcsr->status >> 6)  & 0x1);
 	switch (boot_swapboot) {
@@ -302,7 +599,6 @@
 		case 0xD:
 			/* x16 NAND Flash */
 			nand_width = 0;
-			printk("Pb1550 NAND: 16-bit NAND not supported by MTD\n");
 			break;
 		case 1:
 		case 9:
@@ -314,8 +610,8 @@
 			break;
 		default:
 			printk("Pb1550 NAND: bad boot:swap\n");
-			kfree(au1xxx_nand_mtd);
-			return 1;
+			retval = -EINVAL;
+			goto outmem;
 	}
 #endif
 
@@ -342,29 +638,26 @@
 		au_writel(NAND_STADDR, MEM_STADDR3);
 	}
 #endif
-
-	/* Locate NAND chip-select in order to determine NAND physical address */
+ 
+	/* Locate NAND chip-select in order to determine NAND phys address */
 	mem_staddr = 0x00000000;
 	if (((au_readl(MEM_STCFG0) & 0x7) == 0x5) && (NAND_CS == 0))
 		mem_staddr = au_readl(MEM_STADDR0);
-	else
-	if (((au_readl(MEM_STCFG1) & 0x7) == 0x5) && (NAND_CS == 1))
+	else if (((au_readl(MEM_STCFG1) & 0x7) == 0x5) && (NAND_CS == 1))
 		mem_staddr = au_readl(MEM_STADDR1);
-	else
-	if (((au_readl(MEM_STCFG2) & 0x7) == 0x5) && (NAND_CS == 2))
+	else if (((au_readl(MEM_STCFG2) & 0x7) == 0x5) && (NAND_CS == 2))
 		mem_staddr = au_readl(MEM_STADDR2);
-	else
-	if (((au_readl(MEM_STCFG3) & 0x7) == 0x5) && (NAND_CS == 3))
+	else if (((au_readl(MEM_STCFG3) & 0x7) == 0x5) && (NAND_CS == 3))
 		mem_staddr = au_readl(MEM_STADDR3);
 
 	if (mem_staddr == 0x00000000) {
 		printk("Au1xxx NAND: ERROR WITH NAND CHIP-SELECT\n");
-		kfree(au1xxx_nand_mtd);
+		kfree(au1550_mtd);
 		return 1;
 	}
 	nand_phys = (mem_staddr << 4) & 0xFFFC0000;
 
-	p_nand = (volatile struct nand_regs *)ioremap(nand_phys, 0x1000);
+	p_nand = (void __iomem *)ioremap(nand_phys, 0x1000);
 
 	/* make controller and MTD agree */
 	if (NAND_CS == 0)
@@ -376,35 +669,51 @@
 	if (NAND_CS == 3)
 		nand_width = au_readl(MEM_STCFG3) & (1<<22);
 
+
 	/* Set address of hardware control function */
-	this->hwcontrol = au1xxx_hwcontrol;
-	this->dev_ready = au1xxx_device_ready;
+	this->hwcontrol = au1550_hwcontrol;
+	this->dev_ready = au1550_device_ready;
 	/* 30 us command delay time */
 	this->chip_delay = 30;		
-
-	this->cmdfunc = au1xxx_nand_command;
-	this->select_chip = au1xxx_nand_select_chip;
-	this->write_byte = au1xxx_nand_write_byte;
-	this->read_byte = au1xxx_nand_read_byte;
-	this->write_buf = au1xxx_nand_write_buf;
-	this->read_buf = au1xxx_nand_read_buf;
-	this->verify_buf = au1xxx_nand_verify_buf;
 	this->eccmode = NAND_ECC_SOFT;
 
-	/* Set internal data buffer */
-	this->data_buf = data_buf;
-	this->oob_buf = oob_buf;
+	this->options = NAND_NO_AUTOINCR;
+
+	if (!nand_width)
+		this->options |= NAND_BUSWIDTH_16;
+
+	this->read_byte = (!nand_width) ? au_read_byte16 : au_read_byte;
+	this->write_byte = (!nand_width) ? au_write_byte16 : au_write_byte;
+	this->write_word = au_write_word;
+	this->read_word = au_read_word;
+	this->write_buf = (!nand_width) ? au_write_buf16 : au_write_buf;
+	this->read_buf = (!nand_width) ? au_read_buf16 : au_read_buf;
+	this->verify_buf = (!nand_width) ? au_verify_buf16 : au_verify_buf;
+
+#if 1
+        this->select_chip = au_select_chip;
+        this->cmdfunc = au_command;
+#endif
 
 	/* Scan to find existence of the device */
-	if (nand_scan (au1xxx_nand_mtd, 1)) {
-		kfree (au1xxx_nand_mtd);
-		return -ENXIO;
+	if (nand_scan (au1550_mtd, 1)) {
+		retval = -ENXIO;
+		goto outio;
 	}
 
 	/* Register the partitions */
-	add_mtd_partitions(au1xxx_nand_mtd, partition_info, NB_OF(partition_info));
+	add_mtd_partitions(au1550_mtd, partition_info, NB_OF(partition_info));
 
 	return 0;
+
+ outio:
+	iounmap ((void *)p_nand);
+	
+#ifdef CONFIG_MIPS_PB1550
+ outmem:
+#endif
+	kfree (au1550_mtd);
+	return retval;
 }
 
 module_init(au1xxx_nand_init);
@@ -413,24 +722,22 @@
  * Clean up routine
  */
 #ifdef MODULE
-static void __exit au1xxx_nand_cleanup (void)
+static void __exit au1550_cleanup (void)
 {
-	struct nand_chip *this = (struct nand_chip *) &au1xxx_nand_mtd[1];
+	struct nand_chip *this = (struct nand_chip *) &au1550_mtd[1];
 
-	iounmap ((void *)p_nand);
-
-	/* Unregister partitions */
-	del_mtd_partitions(au1xxx_nand_mtd);
-
-	/* Unregister the device */
-	del_mtd_device (au1xxx_nand_mtd);
+	/* Release resources, unregister device */
+	nand_release (au1550_mtd);
 
 	/* Free the MTD device structure */
-	kfree (au1xxx_nand_mtd);
+	kfree (au1550_mtd);
+
+	/* Unmap */
+	iounmap ((void *)p_nand);
 }
-module_exit(au1xxx_nand_cleanup);
+module_exit(au1550_cleanup);
 #endif
 
 MODULE_LICENSE("GPL");
 MODULE_AUTHOR("Embedded Edge, LLC");
-MODULE_DESCRIPTION("NAND flash support for Alchemy");
+MODULE_DESCRIPTION("Board-specific glue layer for NAND flash on Pb1550 board");
